/***************************************************************************
                          aafc.c  -  description
                             -------------------
    begin                : Fri Jun 25 2002
    copyright            : (C) 2003 by Nobuhiro Kuroiwa
    email                : nobu@iastate.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   any later version                                                     *
 *                                                                         *
 ***************************************************************************/

#include "tiams.h"
#include "aafc.h"
#include "aafcr1.h"

static void AP_app(pFrame self, PEvent e);
FRAME(appObj, OO_SYSTEM_FRAME, 0, OO_APP_FLAGS, 4)
	ATTR(OO_APP_FLAGS, APP_INTERACTIVE)
	ATTR(OO_APP_NAME, "aafc")
	ATTR(OO_APP_PROCESS_EVENT, &AP_app)
	ATTR(OO_APP_DEFAULT_MENU, &AppMenu )
ENDFRAME

pFrame		pAppObj = (pFrame)&appObj;  // Must be 1st!
WINDOW		appW;						// Handle of this app
char		strAns[MAX_ANS_STR];		// stores user's input for answer
char		outStr[ 64];				// stores output for anything
int			aaid;						// aa[aaid], which one selected
int			no_corr_ans;				// number of correct answer
char		strAnsType[][ MAX_ANS_STR]	// kind of answer in string
			=	{ "1-letter", "3-letter", "name"};
BOOL		flgLabel;					// put label or not
TYPE_ANS	type_ans;					// which answer type is selected

//---------------------------------------------------------------------------
//	AP_app()
//	Handles messages
//---------------------------------------------------------------------------
static void AP_app(pFrame self, PEvent e) {
	Access_AMS_Global_Variables;
	WIN_RECT	appWR;
	short		key;
	
	switch (e->command) {
	case	CM_START:
			appWR = *(e->info.startInfo.startRect);
			if (WinOpen( &appW, &appWR, WF_TTY  | WF_DUP_SCR| WF_NOBORDER))
				WinClr( &appW );
			else
				EV_quit();
			//---------------------------------------------------------------
			//	Initialize everything
			//---------------------------------------------------------------
			aaid		= 0;//gly=16
            type_ans	= ANS_TRI;
            flgLabel	= FALSE;
            WinFont( &appW, FONT );
			drawAA();
			break;
	case	ACM_ABOUT:
			DlgNotice(
				"About",
				"Amino Acid Flash Card\nfor TI Ver 0.1\nCopyright(C)2003\n by Nobuhiro Kuroiwa"
			);
			break;
	case	CM_ACTIVATE:
			EV_defaultHandler(e);
			EV_disableCmd(ACM_NOTHING);
			WinBeginPaint( &appW );
			WinActivate( &appW );
			break;
	case	CM_DEACTIVATE:
			WinEndPaint( &appW );
	 		EV_defaultHandler(e);
			break;
	case	CM_QUIT:
			if (appW.Next) {
				WinClose( &appW );
				appW.Next = NULL;
			}
			break;
	case	CM_KEY_PRESS:
			key = e->info.keyInfo.keyCode;
			if( arrowKeyHandler( key) == FALSE)
				EV_defaultHandler(e);
			break;
	case	CM_WPAINT:
			WinBackupToScr( &appW );
			break;
	case	ACM_QSTART	: quizStart();				break;
	case	ACM_QOPT	: quizType();				break;
	case	ACM_RREF	: popupRef();				break;
	case	ACM_ROPT	: labelOnOff();				break;			
	default				: EV_defaultHandler(e);		break;
	}
}

//---------------------------------------------------------------------------
//	arrowKeyHandler()
//	Handles key input to main window
//	changes amino acid to draw by changing aaid
//---------------------------------------------------------------------------
BOOL arrowKeyHandler( short key)
{
	Access_AMS_Global_Variables;
	int	i = 0;

	switch ( key)
	{
	case KB_RIGHT	:
	case KB_UP		:	aaid++;				break;
	case KB_LEFT	:
	case KB_DOWN	:	aaid--;				break;
	case LF_PLUS	:	flgLabel = TRUE;	break;
	case LF_MINUS	:	flgLabel = FALSE;	break;
	default			:
		if( isalpha( key) == 0)		return FALSE;   
		//-------------------------------------------------------------------
		//	If key input corresponds to 1 letter expression of amino acid,
		//	draw it
		//-------------------------------------------------------------------
		for( i = 0; i < 20; i++)
		{
			if( (char)toupper( key) == (char)get1Letter( i))
			{
				aaid = i;
				break;
			}
		}
		if( i == 20)		return	FALSE;
	}
	if( aaid < 0)	aaid = 19;
	if( aaid >= 20)	aaid = 0;
	drawAA();
	return TRUE;	
}

//---------------------------------------------------------------------------
//	myRand()
//	Generates a random number from 0 to 20
//---------------------------------------------------------------------------
short myRand()
{
	Access_AMS_Global_Variables;
    EStackIndex	esi,	range;
	short		i,		counter;
	//-----------------------------------------------------------------------
	//	Do some shit.
	//	push_quan....tive( x) generates 1...x
	//  we need num from 0 so we minus 1 later
	//-----------------------------------------------------------------------
	push_quantum_as_nonnegative_int(20u);
	range	= top_estack;
	push_rand( range);
	esi		= top_estack;
	estack_to_short( esi, &i);
	delete_between( bottom_estack, top_estack);
	//-----------------------------------------------------------------------
	//	index of aa[] of AA is 0 to 19 so we minus 1
	//	cause i=[1,20]
	//-----------------------------------------------------------------------
	return i - 1;
}

//---------------------------------------------------------------------------
//	checkOverlap()
//	check if num is in array[]. max_index is maximum index number
//---------------------------------------------------------------------------
BOOL checkOverlap( short num, short *array, short max_index)
{
	short counter = 0;
	while( counter <= max_index)
	{
		if( array[ counter++] == num)	return TRUE;
	}
	return FALSE;
}

//---------------------------------------------------------------------------
//	quizOption()
//	is called when Quiz->Opt is selected
//	handles action that is selection of kind of answer
//---------------------------------------------------------------------------
void quizType( void)
{
	short	vSelect;
	//-----------------------------------------------------------------------
	//	Open popup window
	//-----------------------------------------------------------------------
	vSelect = popup( strAnsType, 3, "Which to Answer ?", 0);
	if( vSelect == -1)		return;
	//-----------------------------------------------------------------------
	//	Inform a change
	//-----------------------------------------------------------------------
	sprintf(outStr, "%s set to answer ", strAnsType[ vSelect]);
	DlgNotice( "Answer Changed to", outStr );
	//-----------------------------------------------------------------------
	//	save change by overwriting grobal valiable
	//-----------------------------------------------------------------------
	type_ans = vSelect;
}

//---------------------------------------------------------------------------
//	quizStart()
//	is called when Quiz->Start is selected
//	gives 10 questions
//---------------------------------------------------------------------------
void quizStart( void)
{
	Access_AMS_Global_Variables;

	BOOL		esc;
	EStackIndex esi;
	int			counter		= 0;
	int			oldaaid		= aaid;
	BOOL		oldFlgLabel	= flgLabel;
	short		rand_array[ 10];
	//	number of correct answer is initialized	
	no_corr_ans = 0;
	do
	{
		//-------------------------------------------------------------------
		//	get random number and check if the number already obtained
		//	before. Loop untill we get new random number.
		//-------------------------------------------------------------------
		do{
			aaid = myRand();
		} while( checkOverlap( aaid, rand_array, counter) == TRUE);
		rand_array[ counter] = aaid;		
		//-------------------------------------------------------------------
		//	hide label and draw amino acid
		//-------------------------------------------------------------------
		flgLabel= FALSE;
		drawAA();
		//-------------------------------------------------------------------
		//	open dialog that get answer from user and check.
		//	when ESC is pressed, we quit this loop otherwise 10 times loop
		//-------------------------------------------------------------------
		esc = dlgAnswer( counter);
		if( counter++ == 9)
			break;
	}while( esc == FALSE);
	//-----------------------------------------------------------------------
	//	set these values back
	//-----------------------------------------------------------------------
	flgLabel= oldFlgLabel;
	aaid	= oldaaid;
	//-----------------------------------------------------------------------
	//	tell user the score
	//-----------------------------------------------------------------------
	if( counter	== 10) {
		sprintf( outStr, "Score=%d/%d", no_corr_ans, 10);
		DlgNotice( "Score", outStr);
	}
	//-----------------------------------------------------------------------
	//	draw amino acid to screen
	//-----------------------------------------------------------------------
	drawAA();
}

//---------------------------------------------------------------------------
//	callBackDlgAnswer()
//	call back function of a dialog dlgAnswer()
//	creates a popup to say if the answer is correct
//---------------------------------------------------------------------------
DWORD callBackDlgAnswer( WORD dlgId, DWORD Value ) {

	switch( dlgId ) {
	case	0://	If messsage is edit box
			checkAnswer();
			return DB_EXIT;
	default	:
			break;
	}
	return TRUE;
}

//---------------------------------------------------------------------------
//	checkAnswer()
//	check if answer is correct
//---------------------------------------------------------------------------
BOOL checkAnswer( void)
{
	Access_AMS_Global_Variables;
	char	strCorrect[ MAX_ANS_STR];
	int		counter;
	BOOL	ret;
	char	ctemp;
	if( strAns[ 0] == '\0')		return FALSE;
	//-----------------------------------------------------------------------
	//	get correct answer as a string
	//-----------------------------------------------------------------------
	switch( type_ans){
	case ANS_MONO	:	getMonograph(	aaid, strCorrect);	break;
	case ANS_TRI	:	getTrigraph(	aaid, strCorrect);	break;
	case ANS_FULL	:	getName(		aaid, strCorrect);	break;
	// not supporsed to happen
	default			:	strCorrect[0] = '\0';				break;
	}
	//-----------------------------------------------------------------------
	//	Change user's answer(string) to 1st letter capital and rest are lower
	//	cases. 
	//-----------------------------------------------------------------------
	strAns[ 0]	= toupper( strAns[ 0]);
	counter		= 1;
	while( strAns[ counter] != '\0')
	{
		strAns[ counter] = tolower( strAns[ counter]);
		counter++;
	}
	//-----------------------------------------------------------------------
	//	set facial expression and output through dialog as the answer's
	//	correctness.
	//-----------------------------------------------------------------------
	if( strcmp( strCorrect, strAns) == 0)
	{
		strcpy( outStr, ":-)");
		no_corr_ans++;
		ret = TRUE;
	}
	else
	{
		strcpy( outStr, ":(");
		ret = FALSE;
	}
	strcat( outStr, "    ");
	strcat( outStr, strCorrect);
	if( type_ans == ANS_MONO || type_ans == ANS_TRI)
	{
		getName(		aaid, strCorrect);
		strcat( outStr, "\n      ");
		strcat( outStr, strCorrect);
	}
	DlgNotice( "Answer Confirmation", outStr);
	return ret; 
}

//---------------------------------------------------------------------------
//	dlgAnswer()
//	Open a dialog box that receives an answer typed in a edit box
//	returns TRUE to fnixh, FALSE to continue quiz
//---------------------------------------------------------------------------
BOOL dlgAnswer( int q_no ) {
	static	HANDLE		hD1;
	static	WORD		key;
	//-----------------------------------------------------------------------
	//	create popup window
	//-----------------------------------------------------------------------
	if( !(hD1 = DialogNew( 0,0, callBackDlgAnswer )))				return;
	//-----------------------------------------------------------------------
	//	Select a string to be written in edit box
	//-----------------------------------------------------------------------
	switch( type_ans) {
	case ANS_MONO	: strcpy( strAns, "?");		break;
	case ANS_TRI	: strcpy( strAns, "???");	break;
	case ANS_FULL	: strcpy( strAns, "????");	break;
	default			: strcpy( strAns, "Error");	break;
	}	
	//-----------------------------------------------------------------------
	//	add a edit box has an label outStr
	//-----------------------------------------------------------------------
	sprintf( outStr, "Q%d:%s?:", q_no + 1, strAnsType[ type_ans]);
	DialogAdd( hD1, 0, 3, 5, D_EDIT_FIELD, outStr, 0, 16, 6 );
	//-----------------------------------------------------------------------
	//	Open popup window
	//-----------------------------------------------------------------------
	key = DialogDo( hD1, 60, 76, &strAns[0]);
	DialogFree( hD1 );
	//-----------------------------------------------------------------------
	//	if escape key is pressed, return true
	//-----------------------------------------------------------------------
	if( key == KB_ESC)	return TRUE;
	else				return FALSE;
}

//---------------------------------------------------------------------------
//	popup()
//	Adding items stored in lst_item[][], then open popup and return which is
//	selected.
//---------------------------------------------------------------------------
short popup( char lst_item[][MAX_ANS_STR], short num_elem, char *label, short currItm)
{
	HANDLE	hPopup;
	BOOL	vSelect = 0;
	short	counter;
	//-----------------------------------------------------------------------
	//	Create popup window
	//-----------------------------------------------------------------------
	if( !( hPopup = PopupNew( label, 0)))		return -1;
	for( counter = 0; counter < num_elem; counter++)
		DynMenuAdd( hPopup,0,lst_item[counter],counter+1,DMF_TEXT|DMF_TOP);
	//-----------------------------------------------------------------------
	//	If error, free the handle and exit
	//-----------------------------------------------------------------------
	if( !(!(MenuFlags(hPopup) & MF_ERROR)))		goto LBL_POPUP_EXIT;
	//-----------------------------------------------------------------------
	//	Open popup window
	//-----------------------------------------------------------------------
	vSelect = PopupDo( hPopup, -1, -1, currItm + 1);
	//-----------------------------------------------------------------------
	//	If error
	//-----------------------------------------------------------------------
	if( vSelect == 0 )							goto LBL_POPUP_EXIT;
	//-----------------------------------------------------------------------
	//	Forbidden ancient technique
	//-----------------------------------------------------------------------
	goto LBL_POPUP_EXIT;
	LBL_POPUP_EXIT:
	HeapFree( hPopup);
	return vSelect-1;	
}

//---------------------------------------------------------------------------
//	refOption()
//	called when Ref->Label is selected to handle on/off of label
//---------------------------------------------------------------------------
void labelOnOff()
{
	char	list[2][MAX_ANS_STR];
	short	vSelect;
	BOOL	oldFlgLabel = flgLabel;
	strcpy( list[0], "ON");
	strcpy( list[1], "OFF");
	//-----------------------------------------------------------------------
	//	Open popup window
	//-----------------------------------------------------------------------
	vSelect = popup( list, 2, "Label", (short)(flgLabel));
	if( vSelect == -1)	return;
	//-----------------------------------------------------------------------
	//	Obtain what is selected and change
	//-----------------------------------------------------------------------
	if( vSelect == 0)	flgLabel = TRUE;
	else				flgLabel = FALSE;
	//-----------------------------------------------------------------------
	//	If change is new, redraw amino acid
	//-----------------------------------------------------------------------
	if( oldFlgLabel != flgLabel)	drawAA();
}

//---------------------------------------------------------------------------
//	popupRef()
//	Handles an action when "Reference" menu selected
//---------------------------------------------------------------------------
void popupRef( void)
{
	short		vSelect;
	short		counter;
	char		item_list[20][MAX_ANS_STR];
	//-----------------------------------------------------------------------
	//	Open popup window
	//-----------------------------------------------------------------------
	for( counter = 0; counter < 20; counter++)
	{
		// get 3 letter of the amino acid
		getTrigraph( counter, strAns);
		strcpy( item_list[ counter], strAns);
	}
	vSelect = popup( item_list, 20, "Reference", aaid);
	//-----------------------------------------------------------------------
	//	If error, free the handle and exit
	//-----------------------------------------------------------------------
	if( vSelect == -1)		return;
	//-----------------------------------------------------------------------
	//	If the selected item hasn't selected, draw it. If not, do nothing.
	//-----------------------------------------------------------------------
	if( vSelect != aaid)
	{
		aaid = vSelect;
		drawAA();
	}
}

//---------------------------------------------------------------------------
//	drawAA()
//	draws amino acid
//---------------------------------------------------------------------------
void drawAA( )
{
	WinClr( &appW);
	if( aaid == 17)	putAminoAcid( &appW, 21);
	else			putAminoAcid( &appW, 20);
	putAminoAcid(	&appW, aaid	);
	if( flgLabel == TRUE)
		putLabel();
}

//---------------------------------------------------------------------------
//	putLabel()
//	draw label of amino acid to screen
//---------------------------------------------------------------------------
void putLabel()
{
	int height	= WinHeight(&appW);
	int width	= WinWidth( &appW);
	
	getMonograph( aaid, strAns);
	WinMoveTo( &appW, 0, 0);
	WinStr( &appW, strAns);
	
	getTrigraph( aaid, strAns);
	WinMoveTo( &appW, 0, 8);
	WinStr( &appW, strAns);

	getName( aaid, strAns);
	WinMoveTo( &appW, width - ( 1 + strlen( strAns)) * 6, height - 1 * 10);
	WinStr( &appW, strAns);
}



