/***************************************************************************
                          data.h  -  description                             
                             -------------------                             
    begin                : Fri Jun 25 2002                                   
    copyright            : (C) 2003 by Nobuhiro Kuroiwa                      
    email                : nobu@iastate.edu                                  
 ***************************************************************************/
/***************************************************************************
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License, or      *
 *   any later version                                                      *
 *                                                                          *
 ***************************************************************************/
#include "tiams.h"
#ifndef AMINOACID_H
#define AMINOACID_H
#define		ATOM_END			-9
#define		END					-999
#define		TYPE_NODE			char
#define		TYPE_COORDINATES	int
void	putAtom( 		WINDOW		*pappW,		int *x,		int *y,           
						TYPE_NODE	anatom							);       
void	putAminoAcid(	WINDOW		*pappW,		int			aanum	);       
void	putBond(		WINDOW		*pappW,		int 		aanum	);       
void	putGroup( 		WINDOW		*pappW,		int 		aanum	);       
BOOL	array2rect(		WIN_RECT	*prect,                                  
						TYPE_COORDINATES	*array,	 		int level);      
BOOL	checkBorder( int num);                                               
void	getName(		int			num,		char *buf);                  
void	getMonograph( 	int			num,		char *buf);                  
void	getTrigraph(	int			num,		char *buf);
//void	proException( BOOL flgSet);                  
//---------------------------------------------------------------------------
//	Data of each Amino Acid                                                  
//	XXX_Bond[]:                                                              
//		stores coordinates of bonds( lines)                                  
//		array[] = { x00, y00, x01, y01, ..., xn1, yn1, ATOM_END};            
//	XXX_MolPoint[]:                                                          
//		stores coordinate of point that atom sits                            
//		array[] = { x0, y0, x1, y1, ..., xn, yn, ATOM_END};                  
//	XXX_MolNode:                                                             
//		stores notation of molecule. The order correspoinds to               
//		XXX_MolPoint[]. XXX_MolPoin[]={x0,y0,...} and                        
//		XXX_MolNode[]={CH3, ...} put "CH3" on ( x0, y0)                    
//---------------------------------------------------------------------------
//------------------Ala-----------------
const TYPE_COORDINATES Ala_Bond[] = {
	END
};
const TYPE_COORDINATES Ala_MolPoint[] = {
	50,		35,
	END
};
TYPE_NODE *Ala_MolNode[ 2]= {
	"CH3",
	NULL
};

//------------------Val-----------------
const TYPE_COORDINATES Val_Bond[] = {
	53,		32,
	58,		26,
	53,		38,
	58,		44,
	END
};
const TYPE_COORDINATES Val_MolPoint[] = {
	50,		35,
	62,		22,
	60,		47,
	END
};
TYPE_NODE *Val_MolNode[ 4]= {
	"CH",
	"CH3",
	"CH3",
	NULL
};

//------------------Leu-----------------
const TYPE_COORDINATES Leu_Bond[] = {
	55,		35,
	65,		35,
	73,		32,
	78,		26,
	73,		38,
	78,		44,
	END
};
const TYPE_COORDINATES Leu_MolPoint[] = {
	50,		35,
	70,		35,
	82,		22,
	80,		47,
	END
};
TYPE_NODE *Leu_MolNode[ 5]= {
	"CH2",
	"CH",
	"CH3",
	"CH3",
	NULL
};

//------------------Ile-----------------
const TYPE_COORDINATES Ile_Bond[] = {
	53,		32,
	58,		26,
	53,		38,
	58,		44,
	65,		47,
	75,		47,
	END
};
const TYPE_COORDINATES Ile_MolPoint[] = {
	50,		35,
	62,		22,
	60,		47,
	80,		47,
	END
};
TYPE_NODE *Ile_MolNode[ 5]= {
	"CH",
	"CH3",
	"CH2",
	"CH3",
	NULL
};

//------------------Phe-----------------
const TYPE_COORDINATES Phe_Bond[] = {
	55,		35,
	65,		35,
	65,		35,
	75,		47,
	75,		47,
	95,		47,
	95,		47,
	105,		35,
	105,		35,
	95,		23,
	95,		23,
	75,		23,
	75,		23,
	65,		35,
	72,		35,
	78,		43,
	78,		27,
	92,		27,
	92,		43,
	98,		35,
	END
};
const TYPE_COORDINATES Phe_MolPoint[] = {
	50,		35,
	END
};
TYPE_NODE *Phe_MolNode[ 2]= {
	"CH2",
	NULL
};

//------------------Tyr-----------------
const TYPE_COORDINATES Tyr_Bond[] = {
	55,		35,
	65,		35,
	65,		35,
	75,		47,
	75,		47,
	95,		47,
	95,		47,
	105,		35,
	105,		35,
	95,		23,
	95,		23,
	75,		23,
	75,		23,
	65,		35,
	72,		35,
	78,		43,
	78,		27,
	92,		27,
	92,		43,
	98,		35,
	105,		35,
	115,		35,
	END
};
const TYPE_COORDINATES Tyr_MolPoint[] = {
	50,		35,
	120,		35,
	END
};
TYPE_NODE *Tyr_MolNode[ 3]= {
	"CH2",
	"OH",
	NULL
};

//------------------Trp-----------------
const TYPE_COORDINATES Trp_Bond[] = {
	55,		35,
	65,		35,
	65,		35,
	65,		21,
	65,		35,
	100,		35,
	65,		21,
	74,		18,
	100,		21,
	91,		18,
	71,		33,
	71,		23,
	117,		42,
	134,		35,
	134,		35,
	134,		21,
	134,		21,
	117,		14,
	117,		14,
	100,		21,
	100,		21,
	100,		35,
	100,		35,
	117,		42,
	117,		37,
	129,		33,
	105,		33,
	105,		23,
	129,		23,
	117,		19,
	END
};
const TYPE_COORDINATES Trp_MolPoint[] = {
	50,		35,
	82,		14,
	82,		7,
	END
};
TYPE_NODE *Trp_MolNode[ 4]= {
	"CH2",
	"N",
	"H",
	NULL
};

//------------------His-----------------
const TYPE_COORDINATES His_Bond[] = {
	55,		35,
	65,		35,
	65,		35,
	71,		41,
	86,		44,
	96,		42,
	96,		42,
	96,		35,
	86,		26,
	77,		24,
	77,		24,
	65,		35,
	71,		35,
	79,		27,
	91,		40,
	85,		41,
	END
};
const TYPE_COORDINATES His_MolPoint[] = {
	50,		35,
	77,		46,
	96,		14,
	END
};
TYPE_NODE *His_MolNode[ 4]= {
	"CH2",
	"NH",
	"H2N+",
	NULL
};

//------------------Lys-----------------
const TYPE_COORDINATES Lys_Bond[] = {
	55,		35,
	65,		35,
	75,		35,
	85,		35,
	95,		35,
	105,		35,
	115,		35,
	125,		35,
	END
};
const TYPE_COORDINATES Lys_MolPoint[] = {
	50,		35,
	70,		35,
	90,		35,
	110,		35,
	130,		35,
	END
};
TYPE_NODE *Lys_MolNode[ 6]= {
	"CH2",
	"CH2",
	"CH2",
	"CH2",
	"N+H3",
	NULL
};

//------------------Arg-----------------
const TYPE_COORDINATES Arg_Bond[] = {
	55,		35,
	65,		35,
	75,		35,
	85,		35,
	95,		35,
	105,		35,
	115,		35,
	125,		35,
	133,		32,
	138,		26,
	134,		37,
	139,		44,
	131,		39,
	136,		45,
	END
};
const TYPE_COORDINATES Arg_MolPoint[] = {
	50,		35,
	70,		35,
	90,		35,
	110,		35,
	130,		35,
	142,		22,
	140,		47,
	END
};
TYPE_NODE *Arg_MolNode[ 8]= {
	"CH2",
	"CH2",
	"CH2",
	"NH",
	"C",
	"NH2",
	"N+H2",
	NULL
};

//------------------Asp-----------------
const TYPE_COORDINATES Asp_Bond[] = {
	55,		35,
	65,		35,
	73,		32,
	78,		26,
	74,		37,
	79,		44,
	71,		39,
	76,		45,
	END
};
const TYPE_COORDINATES Asp_MolPoint[] = {
	50,		35,
	70,		35,
	82,		22,
	80,		47,
	END
};
TYPE_NODE *Asp_MolNode[ 5]= {
	"CH2",
	"C",
	"O-",
	"O",
	NULL
};

//------------------Glu-----------------
const TYPE_COORDINATES Glu_Bond[] = {
	55,		35,
	65,		35,
	75,		35,
	85,		35,
	93,		32,
	98,		26,
	94,		37,
	99,		44,
	91,		39,
	96,		45,
	END
};
const TYPE_COORDINATES Glu_MolPoint[] = {
	50,		35,
	70,		35,
	90,		35,
	102,		22,
	100,		47,
	END
};
TYPE_NODE *Glu_MolNode[ 6]= {
	"CH2",
	"CH2",
	"C",
	"O-",
	"O",
	NULL
};

//------------------Ser-----------------
const TYPE_COORDINATES Ser_Bond[] = {
	55,		35,
	65,		35,
	END
};
const TYPE_COORDINATES Ser_MolPoint[] = {
	50,		35,
	70,		35,
	END
};
TYPE_NODE *Ser_MolNode[ 3]= {
	"CH2",
	"OH",
	NULL
};

//------------------Thr-----------------
const TYPE_COORDINATES Thr_Bond[] = {
	53,		32,
	58,		26,
	53,		38,
	58,		44,
	END
};
const TYPE_COORDINATES Thr_MolPoint[] = {
	50,		35,
	62,		22,
	60,		47,
	END
};
TYPE_NODE *Thr_MolNode[ 4]= {
	"CH",
	"CH3",
	"OH",
	NULL
};

//------------------Asn-----------------
const TYPE_COORDINATES Asn_Bond[] = {
	55,		35,
	65,		35,
	73,		32,
	78,		26,
	74,		37,
	79,		44,
	71,		39,
	76,		45,
	END
};
const TYPE_COORDINATES Asn_MolPoint[] = {
	50,		35,
	70,		35,
	82,		22,
	80,		47,
	END
};
TYPE_NODE *Asn_MolNode[ 5]= {
	"CH2",
	"C",
	"NH2",
	"O",
	NULL
};

//------------------Gln-----------------
const TYPE_COORDINATES Gln_Bond[] = {
	55,		35,
	65,		35,
	75,		35,
	85,		35,
	93,		32,
	98,		26,
	94,		37,
	99,		44,
	91,		39,
	96,		45,
	END
};
const TYPE_COORDINATES Gln_MolPoint[] = {
	50,		35,
	70,		35,
	90,		35,
	102,		22,
	100,		47,
	END
};
TYPE_NODE *Gln_MolNode[ 6]= {
	"CH2",
	"CH2",
	"C",
	"NH2",
	"O",
	NULL
};

//------------------Gly-----------------
const TYPE_COORDINATES Gly_Bond[] = {
	END
};
const TYPE_COORDINATES Gly_MolPoint[] = {
	50,		35,
	END
};
TYPE_NODE *Gly_MolNode[ 2]= {
	"H",
	NULL
};

//------------------Pro-----------------
const TYPE_COORDINATES Pro_Bond[] = {
	54,		33,
	63,		30,
	63,		26,
	54,		23,
	45,		21,
	35,		21,
	END
};
const TYPE_COORDINATES Pro_MolPoint[] = {
	50,		35,
	67,		28,
	50,		10,
	END
};
TYPE_NODE *Pro_MolNode[ 4]= {
	"CH2",
	"CH2",
	"H2C",
	NULL
};

//------------------Cys-----------------
const TYPE_COORDINATES Cys_Bond[] = {
	55,		35,
	65,		35,
	END
};
const TYPE_COORDINATES Cys_MolPoint[] = {
	50,		35,
	70,		35,
	END
};
TYPE_NODE *Cys_MolNode[ 3]= {
	"CH2",
	"SH",
	NULL
};

//------------------Met-----------------
const TYPE_COORDINATES Met_Bond[] = {
	55,		35,
	65,		35,
	75,		35,
	85,		35,
	95,		35,
	105,		35,
	END
};
const TYPE_COORDINATES Met_MolPoint[] = {
	50,		35,
	70,		35,
	90,		35,
	110,		35,
	END
};
TYPE_NODE *Met_MolNode[ 5]= {
	"CH2",
	"CH2",
	"S",
	"CH3",
	NULL
};

//------------------MC-----------------
const TYPE_COORDINATES MC_Bond[] = {
	30,		48,
	30,		55,
	35,		59,
	44,		62,
	33,		61,
	42,		64,
	26,		60,
	17,		63,
	30,		31,
	30,		25,
	35,		35,
	45,		35,
	END
};
const TYPE_COORDINATES MC_MolPoint[] = {
	30,		35,
	30,		60,
	47,		67,
	13,		67,
	30,		6,
	END
};
TYPE_NODE *MC_MolNode[ 6]= {
	"CH",
	"C",
	"O",
	"O-",
	"H3N+",
	NULL
};
TYPE_NODE *EX_MolNode[ 6] = {
	"CH",
	"C",
	"O",
	"O-",
	"H2N+",
	NULL
};

//TYPE_NODE *PR_MolNode[ 6] = {
struct AminoAcid {
	char					mono_graph;
	char					tri_graph[3];
	char 					*name;
	const TYPE_COORDINATES	*bond;
	const TYPE_COORDINATES	*nodePoint;
	TYPE_NODE				**nodeAtoms;
} aa[] = {
		{ 
		 'A',
		 {'A','l','a'}, "Alanine",
		 Ala_Bond,
		 Ala_MolPoint,
		 Ala_MolNode,
		},																				 // 0
		{ 'V', {'V','a','l'}, "Valine",			Val_Bond,	Val_MolPoint,	Val_MolNode},// 1
		{ 'L', {'L','e','u'}, "Leucine",		Leu_Bond,	Leu_MolPoint,	Leu_MolNode},// 2
		{ 'I', {'I','l','e'}, "Ileucine",		Ile_Bond,	Ile_MolPoint,	Ile_MolNode},// 3
		{ 'F', {'P','h','e'}, "Phenylalanine",	Phe_Bond,	Phe_MolPoint,	Phe_MolNode},// 4
		{ 'Y', {'T','y','r'}, "Tyrosine",		Tyr_Bond,	Tyr_MolPoint,	Tyr_MolNode},// 5
		{ 'W', {'T','r','p'}, "Triptphan",		Trp_Bond,	Trp_MolPoint,	Trp_MolNode},// 6
		{ 'H', {'H','i','s'}, "Histidine",		His_Bond,	His_MolPoint,	His_MolNode},// 7
		{ 'K', {'L','y','s'}, "Lysine",			Lys_Bond,	Lys_MolPoint,	Lys_MolNode},// 8
		{ 'R', {'A','r','g'}, "Arginine",		Arg_Bond,	Arg_MolPoint,	Arg_MolNode},// 9
		{ 'D', {'A','s','p'}, "Aspartic Acid",	Asp_Bond,	Asp_MolPoint,	Asp_MolNode},// 10
		{ 'E', {'G','l','u'}, "Glutamic Acid",	Glu_Bond,	Glu_MolPoint,	Glu_MolNode},// 11
		{ 'S', {'S','e','r'}, "Serine",			Ser_Bond,	Ser_MolPoint,	Ser_MolNode},// 12
		{ 'T', {'T','h','r'}, "Threonine",		Thr_Bond,	Thr_MolPoint,	Thr_MolNode},// 13
		{ 'N', {'A','s','n'}, "Asparagine",		Asn_Bond,	Asn_MolPoint,	Asn_MolNode},// 14
		{ 'Q', {'G','l','n'}, "Glutamine",		Gln_Bond,	Gln_MolPoint,	Gln_MolNode},// 15
		{ 'G', {'G','l','y'}, "Glyusine",		Gly_Bond,	Gly_MolPoint,	Gly_MolNode},// 16
		{ 'P', {'P','r','o'}, "Prorine",		Pro_Bond,	Pro_MolPoint,	Pro_MolNode},// 17
		{ 'C', {'C','y','s'}, "Cystein",		Cys_Bond,	Cys_MolPoint,	Cys_MolNode},// 18
		{ 'M', {'M','e','t'}, "Metionine",		Met_Bond,	Met_MolPoint,	Met_MolNode},// 19
		{ 'Z', {'M','i','B'}, "Men In Black",	MC_Bond,	MC_MolPoint,	MC_MolNode }, // 20
		{ 'X', {'C','B','R'}, "HONDA",			MC_Bond,	MC_MolPoint,	EX_MolNode		}
};
#endif //AMINOACID_H

